---
version: '3.6'
services:
  fsm:
    image: fsm
    ports:
      - '5555:5555'
    restart: always
    depends_on:
      - events
    environment:
      G_MESSAGES_DEBUG: all
      PLANTD_MODULE_ARGS: -vvv
      PLANTD_MODULE_STANDALONE: 'true'
      PLANTD_MODULE_ENDPOINT: tcp://localhost:5555
      PLANTD_MODULE_BROKER: tcp://*:5555
      PLANTD_MODULE_CONFIG_FILE: data/fsm.json
      PLANTD_MODULE_SERVICE: fsm
      PLANTD_EVENTS_FRONTEND: 'tcp://events:10000'
      PLANTD_EVENTS_BACKEND: 'tcp://events:10001'
    networks:
      - plantdnet
  unit_a:
    image: unit_a
    restart: always
    depends_on:
      - fsm
    environment:
      G_MESSAGES_DEBUG: all
      PLANTD_MODULE_ARGS: -vvv
      PLANTD_MODULE_ENDPOINT: tcp://fsm:5555
      PLANTD_MODULE_CONFIG_FILE: data/unit.json
      PLANTD_MODULE_SERVICE: unit_a
      PLANTD_EVENTS_FRONTEND: 'tcp://events:10000'
    networks:
      - plantdnet
  unit_b:
    image: unit_b
    restart: always
    depends_on:
      - fsm
    environment:
      G_MESSAGES_DEBUG: all
      PLANTD_MODULE_ARGS: -vvv
      PLANTD_MODULE_ENDPOINT: tcp://fsm:5555
      PLANTD_MODULE_CONFIG_FILE: data/unit.json
      PLANTD_MODULE_SERVICE: unit_b
      PLANTD_EVENTS_FRONTEND: 'tcp://events:10000'
    networks:
      - plantdnet
  unit_c:
    image: unit_c
    restart: always
    depends_on:
      - fsm
    environment:
      G_MESSAGES_DEBUG: all
      PLANTD_MODULE_ARGS: -vvv
      PLANTD_MODULE_ENDPOINT: tcp://fsm:5555
      PLANTD_MODULE_CONFIG_FILE: data/unit.json
      PLANTD_MODULE_SERVICE: unit_c
      PLANTD_EVENTS_FRONTEND: 'tcp://events:10000'
    networks:
      - plantdnet
  events:
    image: registry.gitlab.com/plantd/plantd/events:v1
    restart: always
    environment:
      PLANTD_EVENTS_FRONTEND: '@tcp://*:10000'
      PLANTD_EVENTS_BACKEND: '@tcp://*:10001'
      PLANTD_EVENTS_LOG_LEVEL: debug
    networks:
      - plantdnet

networks:
  plantdnet:
    driver: bridge
